/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2016 Grigory Filatov <gfilatov@inbox.ru>
 *
*/


#include "minigui.ch"
#include "rmchart.ch"

#define APP_TITLE "Example RMCHART"

#define ID_CHART   1001
#define ID_CHART_2 1002

#define RMC_USERWM         ""               // Your watermark
#define RMC_USERWMCOLOR    RMC_COLOR_BLACK      // Color for the watermark
#define RMC_USERWMLUCENT   30               // Lucent factor between 1(=not visible) and 255(=opaque)
#define RMC_USERWMALIGN    RMC_TEXTCENTER   // Alignment for the watermark
#define RMC_USERFONTSIZE   0                // Fontsize; if 0: maximal size is used

*-----------------------------------------------------------------------------*
PROCEDURE Demo2( oRMChart, nW, nH, nOpcao )
*-----------------------------------------------------------------------------*

        public lDraw := .F.

	SET FONT TO "Tahoma" , 10

	DEFINE WINDOW  Win_1 ;
	        CHILD ;
		AT 0,0 ;
		WIDTH nW ;
		HEIGHT nH ;
		NOSIZE ;
		ICON "demo.ico" ;
		TITLE  APP_TITLE ;
		ON INIT {|| Win_1.Btn_Chart.OnClick } 

		@ nH - 75, 100 BUTTON Btn_Chart ;
			CAPTION "RMCHART" ;
			ACTION Chart( thiswindow.Handle, oRMChart, nW, nH, nOpcao ) ;
			WIDTH 150 HEIGHT 30 DEFAULT

		@ nH - 75, 270 BUTTON Btn_Print ;
			CAPTION "Imprimir" ;
			ACTION PrintChart( thiswindow.Handle ) ;
			WIDTH 150 HEIGHT 30

		@ nH - 75, 440 BUTTON Btn_Cancel ;
			CAPTION "Fechar" ;
			ACTION thiswindow.Release ;
			WIDTH 150 HEIGHT 30

		ON KEY ESCAPE OF Win_1 ACTION {|| thiswindow.Release() }

	END WINDOW

	CENTER WINDOW Win_1
	ACTIVATE WINDOW Win_1

RETURN

*-----------------------------------------------------------------------------*
STATIC PROCEDURE Chart( hWnd, oRMChart, nW, nH, nOpcao )
*-----------------------------------------------------------------------------*

    IF ! lDraw
        lDraw := .T.
        Graphic2( hWnd, oRMChart, ID_CHART, , nW-30, nH-100 )
        oRMChart:Draw( ID_CHART )
        //oRMChart:Draw2Printer( ID_CHART, 0, 0, 0, 0, 0, RMC_BMP )
        //oRMCHart:Reset( ID_CHART )
    ENDIF

Return

#define RMC_PORTRAIT  1
#define RMC_LANDSCAPE 2

*-----------------------------------------------------------------------------*
STATIC PROCEDURE PrintChart( hWnd )
*-----------------------------------------------------------------------------*

   Graphic2( hWnd, oRMChart, ID_CHART_2, 1 )

   IF CallDll( "RMC_DRAW2PRINTER", "RMCHART.DLL", ID_CHART_2, RMC_LANDSCAPE, 10, 10, 220, 150, RMC_EMFPLUS ) < 0

      MsgStop("Print error!")
       
   ENDIF

   oRmChart:DeleteChart( ID_CHART_2 )

Return

*-----------------------------------------------------------------------------*
STATIC PROCEDURE endwindow( lClose )
*-----------------------------------------------------------------------------*
    Default lClose To .T.
    Win_1.Release()
 
Return


*-----------------------------------------------------------------------------*
STATIC FUNCTION Graphic2( hWnd, oRMChart, nIdChart, nExportOnly, nW, nH )
*-----------------------------------------------------------------------------*

LOCAL sTemp, aData

LOCAL sTemp1, aData1, sTemp2, sTemp3 := "", aData2, aData3, aData4, aData5, aData6, aData7, aData8

   DEFAULT nExportOnly TO 0, nW TO 700, nH TO 500

   sTemp1 := "Label 1*Label 2*Label 3*Label 4*Label 5"
   aData1 := { 30,40,70,60,20 }
   sTemp2 := "Label 1*Label 2*Label 3*Label 4*Label 5"
   aData2 := { 20, 10, 15, 25, 30 }
   aData3 := { 25, 30, 10, 20, 15 }
   aData4 := { 10, 20, 40, 20, 30 }
   aData5 := { 40, 30, 20, 30, 20 }
   aData6 := { 30, 50, 20, 40, 60 }
   aData7 := { 240, 230, 220, 180, 170, 160, 145, 130, 125, 115 }
   aData8 := { 162, 124, 86, 44, 24, 62, 104, 228, 146, 84 }

   oRMChart:CreateChart( hWnd, nIdChart, 10, 10, nW, nH, RMC_COLOR_ALICE_BLUE, RMC_CTRLSTYLEFLATSHADOW, .F., "", "", 0, 0 )

   oRMChart:AddRegion( nIdChart, 0, 0, Int( nW / 2 ) - 5, Int( nH / 2 ) - 5, "", .F. )
   oRMChart:AddGrid( nIdChart, 1, RMC_COLOR_BEIGE, .F., 0, 0, 0, 0, RMC_BICOLOR_NONE )
   oRMChart:AddDataAxis( nIdChart, 1, RMC_DATAAXISLEFT, 0, 100, 11, 8, RMC_COLOR_BLACK, RMC_COLOR_BLACK, RMC_LINESTYLESOLID, 0, "", "DATAAXIS1", "", RMC_TEXTCENTER )
   oRMChart:AddLabelAxis( nIdChart, 1, sTemp1, 1, 5, RMC_LABELAXISBOTTOM, 8, RMC_COLOR_BLACK, RMC_TEXTCENTER, RMC_COLOR_BLACK, RMC_LINESTYLESOLID, "LABELAXIS1" )
   oRMChart:AddBarSeries( nIdChart, 1, aData1, 5,RMC_BARSINGLE, RMC_BAR_3D, .F., RMC_COLOR_DEFAULT, .F., 1, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF )

   oRMChart:AddRegion( nIdChart, Int( nW / 2 ) + 1, 0, Int( nW / 2 ) - 5, Int( nH / 2 ) - 5, "", .F. )
   oRMChart:AddGrid( nIdChart, 2, RMC_COLOR_BEIGE, .F., 0, 0, 0, 0, RMC_BICOLOR_NONE )
   oRMChart:AddDataAxis( nIdChart, 2, RMC_DATAAXISTOP, 0, 100, 10, 8, RMC_COLOR_BLACK, RMC_COLOR_BLACK, RMC_LINESTYLESOLID, 0, "", "DATAAXIS2", "", RMC_TEXTCENTER )
   oRMChart:AddLabelAxis( nIdChart, 2, sTemp2, 1, 5, RMC_LABELAXISLEFT,8, RMC_COLOR_BLACK, RMC_TEXTCENTER, RMC_COLOR_BLACK, RMC_LINESTYLESOLID, "LABELAXIS2" )
   oRMChart:AddBarSeries( nIdChart, 2, aData2, 5, RMC_BARSTACKED, RMC_COLUMN_FLAT, .F., RMC_COLOR_DEFAULT, .T., 1, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF )
   oRMChart:AddBarSeries( nIdChart, 2, aData3, 5, RMC_BARSTACKED, RMC_COLUMN_FLAT, .F., RMC_COLOR_DEFAULT, .T., 1, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF )
   oRMChart:AddBarSeries( nIdChart, 2, aData4, 5, RMC_BARSTACKED, RMC_COLUMN_FLAT, .F., RMC_COLOR_DEFAULT, .T., 1, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF )
   oRMChart:AddBarSeries( nIdChart, 2, aData5, 5, RMC_BARSTACKED, RMC_COLUMN_FLAT, .F., RMC_COLOR_DEFAULT, .T., 1, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF )

   oRMChart:AddRegion( nIdChart, 0, Int( nH / 2 ) + 1, Int( nW / 2 ) - 5, Int( nH / 2 ) - 5, "", .F. )
   oRMChart:AddLegend( nIdChart, 3, "AGUA*LUZ*TELEFONE*COMIDA*IMPOSTOS", RMC_LEGEND_ONVLABELS, 0, 0, 0, 0, 0 )
   oRMChart:AddGridlessSeries( nIdChart, 3, aData6, 5, 0, 0, RMC_PIE_3D_GRADIENT, RMC_FULL, 2, .F., RMC_VLABEL_DEFAULT, RMC_HATCHBRUSH_OFF, 0 )

   oRMChart:AddRegion( nIdChart, Int( nW / 2 ) + 1, Int( nH / 2 ) + 1, Int( nW / 2 ) - 5, Int( nH / 2 ) - 5, "", .F.)
   oRMChart:AddGrid( nIdChart, 4, RMC_COLOR_ALICE_BLUE, .T., 0, 0, 0, 0, RMC_BICOLOR_NONE )
   oRMChart:AddDataAxis( nIdChart, 4, RMC_DATAAXISLEFT, 0, 250, 11, 8, RMC_COLOR_BLUE, RMC_COLOR_BLACK, RMC_LINESTYLESOLID, 0, "$", "DATAAXIS4", "", RMC_TEXTCENTER )
   oRMChart:AddLabelAxis( nIdChart, 4, sTemp3, 1, 10, RMC_LABELAXISBOTTOM, 8, RMC_COLOR_BLACK, RMC_TEXTCENTER, RMC_COLOR_BLACK, RMC_LINESTYLESOLID, "LABELAXIS4" )
   oRMChart:AddBarSeries( nIdChart, 4, aData7, 10, RMC_BARSINGLE, RMC_BAR_FLAT_GRADIENT2, .F., RMC_COLOR_GOLD, .F., 1, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF )
   oRMChart:AddLineSeries( nIdChart, 4, aData8, 10, 0, 0, RMC_LINE, RMC_LINE_CABLE, RMC_LSTYLE_LINE, .F., RMC_COLOR_GREEN, RMC_SYMBOL_NONE, 2, RMC_VLABEL_DEFAULT, RMC_HATCHBRUSH_OFF )
   oRMChart:SetWatermark( RMC_USERWM, RMC_USERWMCOLOR, RMC_USERWMLUCENT, RMC_USERWMALIGN, RMC_USERFONTSIZE )
      
RETURN NIL