#include "inkey.ch"
#include "directry.ch"
#include "wvtwin.ch"
#include "hbgtinfo.ch"
#include "hbgtwvg.ch"
#include "wvgparts.ch"
#include "hbcompat.ch"
#include "setcurs.ch"
#include "hmg.ch"

#define DLG_CLR_MOUSE              1
#define DLG_CLR_CAPT               2
#define DLG_CLR_TEXT               3
#define DLG_CLR_BTN                4
#define DLG_CLR_TRG                5
#define DLG_CLR_SHADOW             6
#define DLG_CLR_HILITE             7
#define DLG_CLR_HISEL              8

#define K_MOVING                   1001
#define K_LEFT_DOWN                1002
#define K_LEFT_DBLCLICK            1006
#define K_LEFT_UP                  1003
#define K_RIGHT_DOWN               1004
#define K_RIGHT_DBLCLICK           1007
#define K_RIGHT_UP                 1005

#xtranslate B_CRT <nTop>,<nLeft>,<nBottom>,<nRight> ;
            [ TITLE    <ttl>     ] ;
            [ ICON    <icon>     ] ;
            [ <lModal:MODAL>     ] ;
            [ <lRowCols:RESIZEROWCOLS> ] ;
            [ <lHidden:HIDDEN>   ] ;
            [ <lCenter:CENTER>   ] ;
            [ AT <nRow>,<nCol>   ] ;
            [ <lNoTitleBar:NOTITLEBAR> ] ;
            INTO <oCrt> ;
            => ;
   <oCrt> := CreateOCrt( <nTop>, <nLeft>, <nBottom>, <nRight>, <ttl>, <icon>, ;
                         <.lModal.>, <.lRowCols.>, <.lHidden.>, <.lCenter.>, ;
                         <nRow>, <nCol>, <.lNoTitleBar.> )

*-----------------------------------------------------------------------------*
// F_Win_Frame( b_Block )
*-----------------------------------------------------------------------------*
FUNCTION F_Win_Frame( cCaption, b_Block )
LOCAL oCrt
    oCrt := WvgCrt():New()
    oCrt:lModal  := .T.
    oCrt:visible := .F.
    oCrt:create()
    oCrt:resizable := .F.
    nSel := Eval( b_Block )
    oCrt:destroy()
RETURN Nil

*-----------------------------------------------------------------------------*
// F_Win_Alert
*-----------------------------------------------------------------------------*
FUNCTION F_Wvg_Alert( cMessage, aOptions, cCaption, nInit, nTime )
 LOCAL xAux := ''
RETURN DialogAlert( cCaption, cMessage, aOptions, nInit, , ,nTime )

*-----------------------------------------------------------------------------*
* DialogAlert( cCaption, aText_, aButtons_, sel, aMessage_, nTop, nTime )
*-----------------------------------------------------------------------------*
FUNCTION DialogAlert( cCaption, aText_, aButtons_, sel, aMessage_, nTop, nTime )
  LOCAL nLinesRqd, nColRqd, nLeft, nBottom, nRight, oCrt
  LOCAL nColTxt, nColCap, nColBut, nBtnRow
  LOCAL i, nTopReq, lGo, nKey, nMCol, nMRow, nTrg
  LOCAL maxCol  := maxcol()
  LOCAL maxRow  := maxrow()
  LOCAL nBtnCol_
  LOCAL pal_    := {"gr+/n","gr+/r","n/w","n/bg+","r/bg+","n/w","n/bg","gr+/bg"}
  LOCAL aTrg_   , x_:={}
  LOCAL nPos := 0
  LOCAL cAux := ''

  cCaption  := IIF( EMPTY( cCaption  ), "ATENCAO !!!", cCaption  )
  aButtons_ := IIF( EMPTY( aButtons_ ), {"OK"}       , aButtons_ )
  aText_    := IIF( EMPTY( aText_    ), {}           , aText_    )
  aMessage_ := IIF( EMPTY( aMessage_ ), {}           , aMessage_ )
  sel       := IIF( EMPTY( sel       ), 1            , sel       )
  nTime     := IIF( EMPTY( nTime     ), 10           , nTime     )


  //IF WVG_FindWindow( cCaption ) == -1

    if nTime == 0
       nTime := 10000   //  Seconds
    endif
 
    if valtype( aText_ ) == "C"
      cAux := aText_
      nPos :=  AT( ';', cAux )
      IF nPos > 0
        aText_:= {}
        WHILE nPos > 0
          nPos :=  AT( ';', cAux )
          IF nPos == 0
            AADD( aText_, cAux )
            cAux := ''
            AADD( aText_, cAux )
          ELSE
            IF nPos == 1
              AADD( aText_, '' )
              cAux := ALLTRIM( SUBSTR( cAux, nPos + 1, LEN( cAux ) - ( nPos ) ) )
            ELSE
              AADD( aText_, SUBSTR( cAux, 1, nPos - 1 ) )
              cAux := ALLTRIM( SUBSTR( cAux, nPos + 1, LEN( cAux ) - ( nPos ) ) )
            ENDIF
          ENDIF
        ENDDO
      ELSE
        aText_:= { aText_ }
      ENDIF
    //ENDIF
 
    if valtype(aButtons_) == "C"
       aButtons_:= {aButtons_}
    endif
 
    nLinesRqd := len( aText_ )+ if( len( aText_ )== 0, 4, 5 )
    nTopReq   := int( ( maxRow - nLinesRqd ) / 2 )
    nTop      := if( nTop == nil, nTopReq, if( nTop >  nTopReq, nTop, nTopReq ) )
    nBottom   := nTop + nLinesRqd - 1   // 1 for shadow
 
    // check for columns
    // place 2 spaces before and after the buttons
    nColCap   := len( cCaption )+ 7  // " - "+"  "+caption+"  "
    nColTxt   := 0
    if !empty(aText_)
       aeval(aText_, {|e| nColTxt := max( nColTxt, len( e ) ) } )
    endif
    nColTxt   += 6                   // for two spaces at both sides
    nColBut   := 0
    aeval( aButtons_, {|e| nColBut += len( e ) + 7 } )
    nColBut   += 3
 
    nColRqd   := 0
    aeval( { nColCap, nColTxt, nColBut }, {|e| nColRqd := max( nColRqd, e ) } )
 
    nLeft     := IF( maxCol > nColRqd, int( ( maxCol - nColRqd ) / 2 ), 0 )
    nRight    := nLeft+nColRqd
 
    aTrg_:= array( len( aButtons_ ) )
    for i := 1 to len( aButtons_ )
       aTrg_[i] := upper( substr( aButtons_[ i ], 1, 1 ) )
    next
 
    //                        Create a new Window
    //
    B_CRT nTop, nLeft, nBottom-1, nRight MODAL ICON "ICON_TUTOR______" TITLE '  '+cCaption INTO oCrt
 
    nTop    := -1
    nLeft   := 0
    nBottom := nTop + nLinesRqd - 1
    nRight  := nLeft + nColRqd
    nBtnRow := nTop + 1 + len( aText_ ) + if( len( aText_ ) == 0, 1, 2 )
 
    nBtnCol_  := array( len( aButtons_ ) )
 
    nBtnCol_[ 1 ] := int( ( nColRqd - nColBut ) / 2 ) + 3
    if len( aButtons_ ) > 1
       for i := 2 to len( aButtons_ )
          nBtnCol_[ i ] := nBtnCol_[ i-1 ] + len( aButtons_[ i-1 ] ) + 3 + 4
       next
    ENDIF
 
    setcursor( 0 )
    SetColor( 'n/w' )
    CLS
 
    DispBegin()
    SetColor( pal_[ DLG_CLR_TEXT ] )
 
    Wvg_BoxRaised( nTop, nLeft, nBottom, nRight )
 
    SetColor( pal_[ DLG_CLR_TEXT ] )
    if !empty( aText_ )
       FOR  i := 1 to len( aText_ )
          @ nTop+1+i, nLeft SAY padc( aText_[ i ], nRight-nLeft+1 )
       NEXT
    ENDIF
 
    // display buttons
    //
    for i := 1 to len( aButtons_ )
       SetColor( pal_[ DLG_CLR_BTN ] )
       @ nBtnRow, nBtnCol_[ i ] SAY "  "+aButtons_[ i ]+"  "
       SetColor( pal_[ DLG_CLR_TRG ] )
       @ nBtnRow, nBtnCol_[ i ]+2 say substr( aButtons_[ i ],1,1 )
 
       aadd( x_, { nBtnRow, nBtnCol_[ i ], nBtnRow, nBtnCol_[ i ] + len( aButtons_[ i ] ) + 3 } )
    next
 
    setColor( pal_[ DLG_CLR_HILITE ] )
    @ nBtnRow, nBtnCol_[ sel ] SAY "  "+aButtons_[sel]+"  "
 
    setColor( pal_[ DLG_CLR_HISEL ] )
    @ nBtnRow, nBtnCol_[ sel ]+2 SAY substr( aButtons_[ sel ],1,1 )
 
    aeval( x_, {|e_| Wvg_BoxRaised( e_[ 1 ], e_[ 2 ], e_[ 3 ], e_[ 4 ] ) } )
 
    dispend()
 
    lGo := .t.
    do while lGo
       IF ( nKey := Inkey() ) == 0
          LOOP
       ENDIF
 
       if nKey == K_ESC
          sel := 0
          exit
       endif
       nMRow := MRow()
       nMCol := MCol()
 
       do case
       case nKey == K_RIGHT_DOWN
          sel := 0
          lGo := .f.
       case nKey == K_LEFT_DOWN
          if nMRow == nTop
             if nMCol >= nLeft .and. nMCol <= nLeft+3
                sel := 0
                lGo := .f.
             endif
          elseif nMRow == nBtnRow
             for i := 1 to len( nBtnCol_ )
                if nMCol >= nBtnCol_[ i ] .and. nMCol <= nBtnCol_[ i ] + len( aButtons_[ i ] )+4
                   sel := i
                   lGo := .f.
                endif
             next
          endif
       case nKey == K_ESC
          sel := 0
          lGo := .f.
       case nKey == K_ENTER
          lGo := .f.
       case nKey == K_LEFT  .or. nKey == K_DOWN
          sel--
       case nKey == K_RIGHT .or. nKey == K_UP
          sel++
       case ( nTrg := ascan( aTrg_, upper( chr( nKey ) ) ) ) > 0
          sel := nTrg
          lGo := .f.
       otherwise
          if setkey( nKey ) != nil
             eval( setKey( nKey ) )
          endif
       endcase
 
       if sel > len( aButtons_ )
          sel := 1
       elseif sel < 1
          sel := len( aButtons_ )
       endif
 
       dispbegin()
       for i := 1 to len ( aButtons_ )
          setColor( pal_[ DLG_CLR_BTN ] )
          @ nBtnRow, nBtnCol_[ i ] SAY "  "+aButtons_[i]+"  "
          setColor( pal_[ DLG_CLR_TRG])
          @ nBtnRow, nBtnCol_[i]+2 say substr(aButtons_[i],1,1)
       next
       if sel > 0
          setColor( pal_[ DLG_CLR_HILITE ] )
          @ nBtnRow, nBtnCol_[sel] SAY "  "+aButtons_[ sel ]+"  "
          setColor( pal_[ DLG_CLR_HISEL ] )
          @ nBtnRow, nBtnCol_[ sel ]+2 SAY substr( aButtons_[ sel ], 1, 1 )
       endif
 
       dispend()
    enddo
 
    oCrt:destroy()

  ENDIF

return sel

*-----------------------------------------------------------------------------*
* CreateOCrt( nT, nL, nB, nR, cTitle, xIcon, lModal, lRowCols, lHidden, lCenter, nRow, nCol, lNoTitleBar )
*-----------------------------------------------------------------------------*
FUNCTION CreateOCrt( nT, nL, nB, nR, cTitle, xIcon, lModal, lRowCols, lHidden, lCenter, nRow, nCol, lNoTitleBar )
   LOCAL oCrt, aPos

   cTitle      := IIF( EMPTY( cTitle      ), 'Info'  ,cTitle      )
   xIcon       := IIF( EMPTY( xIcon       ), 'VW_DFT',xIcon       )
   lModal      := IIF( EMPTY( lModal      ), .T.     ,lModal      )
   lHidden     := IIF( EMPTY( lHidden     ), .F.     ,lHidden     )
   lCenter     := IIF( EMPTY( lCenter     ), .F.     ,lCenter     )
   lNoTitleBar := IIF( EMPTY( lNoTitleBar ), .F.     ,lNoTitleBar )

   aPos := IF( lCenter, {-1,-1}, IF( nRow == NIL, { nT, nL }, { nRow,nCol } ) )

   oCrt := WvgCrt():new( , , aPos, { nB - nT, nR - nL }, , !lHidden )
   oCrt:lModal := lModal
   IF lRowCols
      oCrt:resizeMode := HB_GTI_RESIZEMODE_ROWS
   ENDIF
   oCrt:create()
   SetCursor( 0 )

   IF hb_isNumeric( xIcon )
      Hb_GTInfo( HB_GTI_ICONRES, xIcon )
   ELSE
      IF ( '.ico' $ lower( xIcon ) )
         Hb_GTInfo( HB_GTI_ICONFILE, xIcon )
      ELSE
         IF '.bmp' $ lower( xIcon )
            xIcon := 'VW_DFT'
         ENDIF
         Hb_GTInfo( HB_GTI_ICONRES, xIcon )
      ENDIF
   ENDIF

   Hb_GTInfo( HB_GTI_WINTITLE, cTitle )

   SetColor( 'n/w' )
   CLS

RETURN oCrt

*-----------------------------------------------------------------------------*
// F_Exemplo_Alert( )
*-----------------------------------------------------------------------------*
FUNCTION F_Exemplo_Alert( )
  LOCAL i := 0
  LOCAL nCol := MaxCol()+1
  LOCAL nRow := MaxRow()+1

  CLS

  FOR i := 1 TO nRow
    ? STR( i )
  NEXT
  @i-2,nCol-10 SAY STR( nCol )

  TONE( ( nCol * 10 ), ( 5 ) )

  ALERT( 'INTERESSANTE: MAS PODE MELHORAR...' )

RETURN( NIL )

*-----------------------------------------------------------------------------*
// F_Exemplo_Wvg_Alert( )
*-----------------------------------------------------------------------------*
FUNCTION F_Exemplo_Wvg_Alert( )

   hb_GtInfo( HB_GTI_RESIZABLE, .F. )
   //hb_gtInfo(HB_GTI_COMPATBUFFER, .F. ) 
   hb_gtInfo(HB_GTI_CLOSABLE, .T. )
   //hb_gtinfo(HB_GTI_NOTIFIERBLOCKGUI, {|nEvent| MyEvent(nEvent)})
   screenWidth := hb_GtInfo( HB_GTI_DESKTOPWIDTH )
   screenHeight:= hb_GtInfo( HB_GTI_DESKTOPHEIGHT ) 
   WVT_SetFont( "Lucida Console", Round(( screenHeight / MaxRow() ),0)-4, Round(( screenWidth / MaxCol() ),0), 0 )
   WVT_Maximize()

  cColorGet    := "W+/BG, B/GR*,,,W+/W" 
   
  SetColor( cColorGet )
   
  CLS

  @ 0,0 say hb_ntos(nrow)
  @ 1,0 say hb_ntos(nCol)

  cNome:=Space(40)
  
  @ 10,00 SAY "Nome: " GET cNome COLOR cColorGet
  READ

  IF LastKey() = 27
     RETURN Nil
  ENDIF
  
  @ nRow-1,0      SAY hb_ntos( nRow )
  @ nRow-1,nCol-3 SAY hb_ntos( nCol )

  TONE( ( nCol * 10 ), ( 5 ) )

  //nOpcao:=F_Wvg_Alert( 'PARECE FACIL MIGRAR PARA HMG + WVG...;teste;'+hb_Version()+';'+HB_Compiler()+';'+MiniguiVersion(),{"Ok","Sair"},"TESTE COM WVG" )

RETURN( NIL )

FUNCTION MyEvent(eSai)
   IF eSai==HB_GTE_CLOSE
     IF MsgYesNo("Deseja sair do programa ?", "Ateno")
        
     ENDIF
   ENDIF
RETURN Nil


FUNCTION TESTEWVG( )

   REQUEST HB_LANG_PT
   
   REQUEST HB_CODEPAGE_PT850
   
   HB_LANGSELECT("PT")
   
   HB_CDPSELECT( "PT850" ) 

   pNewGT := HB_GTCREATE("WVG")
   pGT    := HB_GTSELECT( pNewGT )

   SetMode( 25, 80 )

   hb_gtInfo( HB_GTI_FONTNAME, "Lucida Console")
   hb_gtInfo( HB_GTI_RESIZABLE , .F. )
   hb_gtInfo( HB_GTI_ICONRES, "ICON_ASAPREV" )
   hb_gtInfo( HB_GTI_WINTITLE, "TESTE HMG + WVG")
   hb_gtInfo( HB_GTI_CLOSABLE, .F. )
   hb_gtInfo( HB_GTI_CLIPBOARDDATA )
   hb_gtInfo( HB_GTI_SELECTCOPY, .T. )
   hb_gtInfo( HB_GTI_MOUSESTATUS, 1 )
   hb_gtInfo( HB_GTI_ISGRAPHIC, .T. )
   hb_gtInfo( HB_GTI_STDERRCON, .T. )
   hb_gtInfo( HB_GTI_COMPATBUFFER, .T. ) 
   hb_gtInfo( HB_GTI_FONTSIZE, 20 )
   hb_gtInfo( HB_GTI_FONTWIDTH, 11 )
   hb_gtInfo( HB_GTI_FONTWEIGHT, 8 )
   hb_gtInfo( HB_GTI_SPEC, HB_GTS_WNDSTATE, HB_GTS_WS_MAXIMIZED )
   hb_gtInfo( HB_GTI_SPEC, HB_GTS_SHOWWINDOW, SW_NORMAL )
   hb_gtInfo( HB_GTI_MAXIMIZED, .T. )
   
   cColorGet    := "W+/BG, B/GR*,,,W+/W" 
   
   SetColor( cColorGet )
   
   CLS
   
   @ 00,00 SAY hb_DateTime()

   cNome := Space(40)
   
    
   @ 10,00 SAY "Nome: " GET cNome COLOR cColorGet
   READ
   
   WAPI_DestroyWindow( hb_gtInfo( HB_GTI_WINHANDLE ) )
   
RETURN( NIL )

FUNCTION TESTEWVT( )

   REQUEST HB_LANG_PT
   
   REQUEST HB_CODEPAGE_PT850
   
   HB_LANGSELECT("PT")
   
   HB_CDPSELECT( "PT850" ) 

   pNewGT := HB_GTCREATE("WVT")
   pGT    := HB_GTSELECT( pNewGT )

   SetMode( 25, 80 )

   hb_gtInfo( HB_GTI_FONTNAME, "Lucida Console")
   hb_gtInfo( HB_GTI_RESIZABLE , .F. )
   hb_gtInfo( HB_GTI_ICONRES, "ICON_ASAPREV" )
   hb_gtInfo( HB_GTI_WINTITLE, "TESTE HMG + WVT")
   hb_gtInfo( HB_GTI_CLOSABLE, .F. )
   hb_gtInfo( HB_GTI_CLIPBOARDDATA )
   hb_gtInfo( HB_GTI_SELECTCOPY, .T. )
   hb_gtInfo( HB_GTI_MOUSESTATUS, 1 )
   hb_gtInfo( HB_GTI_ISGRAPHIC, .T. )
   hb_gtInfo( HB_GTI_STDERRCON, .T. )
   hb_gtInfo( HB_GTI_COMPATBUFFER, .T. ) 
   hb_gtInfo( HB_GTI_FONTSIZE, 20 )
   hb_gtInfo( HB_GTI_FONTWIDTH, 11 )
   hb_gtInfo( HB_GTI_FONTWEIGHT, 8 )
   //hb_gtInfo( HB_GTI_SPEC, HB_GTS_WNDSTATE, HB_GTS_WS_MAXIMIZED )
   hb_gtInfo( HB_GTI_SPEC, HB_GTS_SHOWWINDOW, SW_NORMAL )
   //hb_gtInfo( HB_GTI_MAXIMIZED, .T. )
   
   cColorGet    := "W+/BG, B/GR*,,,W+/W" 
   
   SetColor( cColorGet )
   
   CLS
   
   @ 00,00 SAY hb_DateTime()

   cNome := Space(40)
   
    
   @ 10,00 SAY "Nome: " GET cNome COLOR cColorGet
   READ
   
   WAPI_DestroyWindow( hb_gtInfo( HB_GTI_WINHANDLE ) )
   
RETURN Nil

*-----------------------------------------------------------------------------*
// F_Exemplo_Alert( )
*-----------------------------------------------------------------------------*
FUNCTION F_Exemplo_Alert_Padrao( )
  LOCAL i := 0
  LOCAL nCol := MaxCol()+1
  LOCAL nRow := MaxRow()+1

  CLS

  FOR i := 1 TO nRow
    ? STR( i )
  NEXT
  @i-2,nCol-10 SAY STR( nCol )

  //TONE( ( nCol * 10 ), ( 5 ) )

  nOpcao:=My_Alert( "How did you like the 'Alert' replacement?", { "WOW", "OK", "OOps" } )

RETURN( NIL )

*-----------------------------------------------------------------------------*
// F_Exemplo_Wvg_Alert( )
*-----------------------------------------------------------------------------*
FUNCTION F_Exemplo_Wvg_Alert_Padrao( )
  LOCAL i := 0
  LOCAL nCol := MaxCol()+1
  LOCAL nRow := MaxRow()+1

  CLS

  FOR i := 1 TO nRow
    ? STR( i )
  NEXT
  @i-2,nCol-10 SAY STR( nCol )

  TONE( ( nCol * 10 ), ( 5 ) )

  F_Wvg_Alert( 'BONITINHO, MAS CONSTRANGEDOR;;ESSA TELA TAMBEM NAO SOME...;;;FALTA CONTROLE DA JANELA...;;;VAMOS VER COM A CLASSE WcgCrt',,"TESTE COM WVG" )

RETURN( NIL )

FUNCTION My_Alert( cMessage, aOptions, cCaption, nInit, nTime )
   RETURN DialogAlert2( cCaption, cMessage, aOptions, nInit,, nTime )

FUNCTION MyAlert( cMsg, aOpt )

   LOCAL nSel, oCrt

   oCrt := WvgCrt():New( , , { -1, -1 }, { 9, MaxCol() - 6 }, , .T. )
   oCrt:lModal := .T.
   oCrt:icon   := "dia_excl.ico"
   oCrt:create()
   oCrt:resizable := .T.

   SetColor( "N/W" )
   CLS
   hb_gtInfo( HB_GTI_WINTITLE, cMsg )

   nSel := Alert( cMsg, aOpt )

   oCrt:destroy()

   RETURN nSel
   
 FUNCTION DialogAlert2( cCaption, aText_, aButtons_, sel, nTop, nTime )

   LOCAL nLinesRqd, nColRqd, nLeft, nBottom, nRight, oCrt
   LOCAL nColTxt, nColCap, nColBut, nBtnRow
   LOCAL i, nTopReq, lGo, nKey, nKeyStd, nMCol, nMRow, nTrg
   LOCAL maxCol  := MaxCol()
   LOCAL maxRow  := MaxRow()
   LOCAL nBtnCol_
   LOCAL pal_    := { "w+/n", "w/r", "n/w", "n/bg", "r/bg", "N/W", "n/B", "w+/B" }
   LOCAL aTrg_, x_ := {}

   hb_default( @cCaption, "Your Attention Please!" )
   hb_default( @sel     , 1 )
   hb_default( @nTime   , 10 )

   IF nTime == 0
      nTime := 10000   //  Seconds
   ENDIF

   IF HB_ISSTRING( aText_ )
      aText_ := { aText_ }
   ENDIF

   hb_default( @aText_, {} )

   IF HB_ISSTRING( aButtons_ )
      aButtons_ := { aButtons_ }
   ENDIF

   hb_default( @aButtons_, { "OK" } )

   nLinesRqd := Len( aText_ ) + iif( Len( aText_ ) == 0, 4, 5 )
   nTopReq   := Int( ( maxRow - nLinesRqd ) / 2 )
   nTop      := iif( HB_ISNUMERIC( nTop ), iif( nTop > nTopReq, nTop, nTopReq ), nTopReq )
   nBottom   := nTop + nLinesRqd - 1   // 1 for shadow

   // check for columns
   // place 2 spaces before and after the buttons
   nColCap   := Len( cCaption ) + 7  // " - " + "  " + cCaption + "  "
   nColTxt   := 0
   IF ! Empty( aText_ )
      AEval( aText_, {| e | nColTxt := Max( nColTxt, Len( e ) ) } )
   ENDIF
   nColTxt   += 6                   // for two spaces at both sides
   nColBut   := 0
   AEval( aButtons_, {| e | nColBut += Len( e ) + 7 } )
   nColBut   += 3

   nColRqd   := 0
   AEval( { nColCap, nColTxt, nColBut }, {| e | nColRqd := Max( nColRqd, e ) } )

   nLeft     := iif( maxCol > nColRqd, Int( ( maxCol - nColRqd ) / 2 ), 0 )
   nRight    := nLeft + nColRqd

   aTrg_ := Array( Len( aButtons_ ) )
   FOR i := 1 TO Len( aButtons_ )
      aTrg_[ i ] := Left( aButtons_[ i ], 1 )
   NEXT

   // Create a new Window
   B_CRT nTop, nLeft, nBottom - 1, nRight MODAL ICON "dia_excl.ico" TITLE "  " + cCaption INTO oCrt

   nTop    := -1
   nLeft   := 0
   nBottom := nTop + nLinesRqd - 1
   nRight  := nLeft + nColRqd
   nBtnRow := nTop + 1 + Len( aText_ ) + iif( Len( aText_ ) == 0, 1, 2 )

   nBtnCol_  := Array( Len( aButtons_ ) )

   nBtnCol_[ 1 ] := Int( ( nColRqd - nColBut ) / 2 ) + 3
   IF Len( aButtons_ ) > 1
      FOR i := 2 TO Len( aButtons_ )
         nBtnCol_[ i ] := nBtnCol_[ i - 1 ] + Len( aButtons_[ i - 1 ] ) + 3 + 4
      NEXT
   ENDIF

   SetCursor( SC_NONE )
   SetColor( "N/W" )
   CLS

   DispBegin()
   SetColor( pal_[ DLG_CLR_TEXT ] )

   wvg_BoxRaised( nTop, nLeft, nBottom, nRight )

   SetColor( pal_[ DLG_CLR_TEXT ] )
   IF ! Empty( aText_ )
      FOR i := 1 TO Len( aText_ )
         @ nTop + 1 + i, nLeft SAY PadC( aText_[ i ], nRight - nLeft + 1 )
      NEXT
   ENDIF

   // display buttons
   FOR i := 1 TO Len( aButtons_ )
      SetColor( pal_[ DLG_CLR_BTN ] )
      @ nBtnRow, nBtnCol_[ i ] SAY "  " + aButtons_[ i ] + "  "
      SetColor( pal_[ DLG_CLR_TRG ] )
      @ nBtnRow, nBtnCol_[ i ] + 2 SAY Left( aButtons_[ i ], 1 )

      AAdd( x_, { nBtnRow, nBtnCol_[ i ], nBtnRow, nBtnCol_[ i ] + Len( aButtons_[ i ] ) + 3 } )
   NEXT

   SetColor( pal_[ DLG_CLR_HILITE ] )
   @ nBtnRow, nBtnCol_[ sel ] SAY "  " + aButtons_[ sel ] + "  "

   SetColor( pal_[ DLG_CLR_HISEL ] )
   @ nBtnRow, nBtnCol_[ sel ] + 2 SAY Left( aButtons_[ sel ], 1 )

   AEval( x_, {| e_ | wvg_BoxRaised( e_[ 1 ], e_[ 2 ], e_[ 3 ], e_[ 4 ] ) } )

   DispEnd()

   lGo := .T.
   DO WHILE lGo

      nKeyStd := hb_keyStd( nKey := Inkey( 0, hb_bitOr( Set( _SET_EVENTMASK ), HB_INKEY_EXT ) ) )

      IF nKey == 0
         LOOP
      ENDIF

      IF nKeyStd == K_ESC
         sel := 0
         EXIT
      ENDIF
      nMRow := MRow()
      nMCol := MCol()

      DO CASE
      CASE nKeyStd == K_RIGHT_DOWN
         sel := 0
         lGo := .F.
      CASE nKeyStd == K_LEFT_DOWN
         IF nMRow == nTop
            IF nMCol >= nLeft .AND. nMCol <= nLeft + 3
               sel := 0
               lGo := .F.
            ENDIF
         ELSEIF nMRow == nBtnRow
            FOR i := 1 TO Len( nBtnCol_ )
               IF nMCol >= nBtnCol_[ i ] .AND. nMCol <= nBtnCol_[ i ] + Len( aButtons_[ i ] ) + 4
                  sel := i
                  lGo := .F.
               ENDIF
            NEXT
         ENDIF
      CASE nKeyStd == K_ESC
         sel := 0
         lGo := .F.
      CASE nKeyStd == K_ENTER
         lGo := .F.
      CASE nKeyStd == K_LEFT .OR. nKeyStd == K_DOWN
         --sel
      CASE nKeyStd == K_RIGHT .OR. nKeyStd == K_UP
         ++sel
      CASE ( nTrg := hb_AScanI( aTrg_, hb_keyChar( nKey ), , , .T. ) ) > 0
         sel := nTrg
         lGo := .F.
      CASE SetKey( nKey ) != NIL
         Eval( SetKey( nKey ) )
      CASE SetKey( nKeyStd ) != NIL
         Eval( SetKey( nKeyStd ) )
      ENDCASE

      IF sel > Len( aButtons_ )
         sel := 1
      ELSEIF sel < 1
         sel := Len( aButtons_ )
      ENDIF

      DispBegin()
      FOR i := 1 TO Len( aButtons_ )
         SetColor( pal_[ DLG_CLR_BTN ] )
         @ nBtnRow, nBtnCol_[ i ] SAY "  " + aButtons_[ i ] + "  "
         SetColor( pal_[ DLG_CLR_TRG ] )
         @ nBtnRow, nBtnCol_[ i ] + 2 SAY Left( aButtons_[ i ], 1 )
      NEXT
      IF sel > 0
         SetColor( pal_[ DLG_CLR_HILITE ] )
         @ nBtnRow, nBtnCol_[ sel ] SAY "  " + aButtons_[ sel ] + "  "
         SetColor( pal_[ DLG_CLR_HISEL ] )
         @ nBtnRow, nBtnCol_[ sel ] + 2 SAY Left( aButtons_[ sel ], 1 )
      ENDIF

      DispEnd()
   ENDDO

   oCrt:destroy()

   RETURN sel
   
FUNCTION GtSetupPalette
LOCAL aPaletteRgb, aPalette, nCont

aPalette := { ;
         wapi_Rgb(  30, 30,   30 ), ; //  0 N   Black      Preto                   New Form Font Color
         wapi_Rgb(   0,  0,  140 ), ; //  1 B   Blue       Azul 170
         wapi_Rgb(  54,  66,   6 ), ; //  2 G   Green      Verde
         wapi_Rgb(   0, 133, 133 ), ; //  3 BG  Cyan       Azul Celeste            Title and Selected BackGround
         wapi_Rgb( 150,   0,   0 ), ; //  4 R   Red        Vermelho
         wapi_Rgb( 133,   0, 133 ), ; //  5 RB  Magenta    Rosa
         wapi_Rgb( 255, 255,   0 ), ; //  6 GR  Brown      Marrom
         wapi_Rgb( 240, 240, 240 ), ; //  7 W   White      Branco
         wapi_Rgb(  240,  240,  240 ), ; //  8 N+  Gray       Cinza
         wapi_Rgb(   0, 114, 198 ), ; //  9 B+  +Blue      Azul Claro
         wapi_Rgb(  42,  42,  42 ), ; // 10 G+  +Green     Verde Claro // 0,96,64
         wapi_Rgb( 132, 150, 173 ), ; // 11 BG+ +Cyan      Azul Celeste Claro
         wapi_Rgb( 248,   0,  38 ), ; // 12 R+  +Red       Vermelho Claro          Alert
         wapi_Rgb(  64,   0,  64 ), ; // 13 RB+ +Magenta   Rosa Claro
         wapi_Rgb( 216, 152,   0 ), ; // 14 GR+ Yellow     Amarelo
         wapi_Rgb( 255, 255, 255 ) }  // 15 W+  +White     Branco Claro            New Get and Selected Font Color

    hb_gtInfo( HB_GTI_PALETTE, aPalette )
RETURN Nil