/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2016 Grigory Filatov <gfilatov@inbox.ru>
 *
*/


#include "minigui.ch"
#include "rmchart.ch"

#define APP_TITLE "Example RMCHART"

#define ID_CHART   1001
#define ID_CHART_2 1002

*-----------------------------------------------------------------------------*
PROCEDURE Demo1( oRMChart, nW, nH, nOpcao )
*-----------------------------------------------------------------------------*
   
        PUBLIC lDraw := .F.

	SET FONT TO "Tahoma" , 10

	DEFINE WINDOW  Win_1 ;
	        CHILD ;
		AT 0,0 ;
		WIDTH nW ;
		HEIGHT nH ;
		NOSIZE ;
		ICON "demo.ico" ;
		TITLE  APP_TITLE ;
		ON INIT {|| Win_1.Btn_Chart.OnClick } 

		@ nH - 75, 100 BUTTON Btn_Chart ;
			CAPTION "RMCHART" ;
			ACTION Chart( thiswindow.Handle, oRMChart, nW, nH, nOpcao ) ;
			WIDTH 150 HEIGHT 30 DEFAULT

		@ nH - 75, 270 BUTTON Btn_Print ;
			CAPTION "Imprimir" ;
			ACTION PrintChart( thiswindow.Handle, oRMChart ) ;
			WIDTH 150 HEIGHT 30

		@ nH - 75, 440 BUTTON Btn_Cancel ;
			CAPTION "Fechar" ;
			ACTION thiswindow.Release ;
			WIDTH 150 HEIGHT 30

		ON KEY ESCAPE OF Win_1 ACTION {|| thiswindow.Release() }

	END WINDOW

	CENTER WINDOW Win_1
	ACTIVATE WINDOW Win_1

RETURN

*-----------------------------------------------------------------------------*
STATIC PROCEDURE Chart( hWnd, oRMChart, nW, nH, nOpcao )
*-----------------------------------------------------------------------------*

    IF ! lDraw
        lDraw := .T.
        Graphic1( hWnd, oRMChart, ID_CHART, , nW-30, nH-100 )
        oRMChart:Draw( ID_CHART )
        //oRMChart:Draw2Printer( ID_CHART, 0, 0, 0, 0, 0, RMC_EMF  )
        //oRMChart:Draw2Clipboard( ID_CHART, RMC_BMP  )
        //oRMCHart:Reset( ID_CHART )
        //oRMChart:Draw2Printer( ID_CHART, 0, 0, 0, 0, 0, RMC_BMP )
    ENDIF

Return

#define RMC_PORTRAIT  1
#define RMC_LANDSCAPE 2

*-----------------------------------------------------------------------------*
STATIC PROCEDURE PrintChart( hWnd, oRMChart )
*-----------------------------------------------------------------------------*

   //Graphic1( hWnd, oRMChart, ID_CHART, 1 )

   //IF CallDll( "RMC_DRAW2PRINTER", "RMCHART.DLL", ID_CHART ) < 0
   IF oRMChart:DRAW2PRINTER( ID_CHART, RMC_LANDSCAPE, 10.0, 10.0, 220.0, 150.0, RMC_EMF  ) < 0
      MsgStop("Print error!")
   ELSE
      MsgInfo("OK")
       
   ENDIF

   //oRmChart:DeleteChart( ID_CHART_2 )

Return

*-----------------------------------------------------------------------------*
STATIC PROCEDURE endwindow( lClose )
*-----------------------------------------------------------------------------*
    Default lClose To .T.
    Win_1.Release()
 
Return

*-----------------------------------------------------------------------------*
STATIC FUNCTION AMax( x )
*-----------------------------------------------------------------------------*

   LOCAL nVal, oElement

   nVal := x[ 1 ]
   FOR EACH oElement IN x
      IF oElement > nVal
         nVal := oElement
      ENDIF
   NEXT

   RETURN nVal

*-----------------------------------------------------------------------------*
STATIC FUNCTION Graphic1( hWnd, oRMChart, nIdChart, nExportOnly, nW, nH )
*-----------------------------------------------------------------------------*

LOCAL cLegenda, cLabels, cTitulo, aDados, cImagem, cUnidade, cTextoVert, nMax, oElement, nCont, GetList:={}

   DEFAULT nExportOnly TO 0, nW TO 650 , nH TO 450 // 680 x 550

  
   cLegenda   := "Entradas*Saidas*Mais Um"
   cLabels    := "Janeiro*Fevereiro*Maro*Abril*Maio*Junho*Julho*Agosto*Setembro*Outubro*Novembro*Dezembro"
   cTitulo    := "Grfico de Teste"
   aDados     := { ;
                 { 225.25, 100.00, 100.00, 150.00, 250.00, 300.00, 25.00, 75.00, 300.00, 200.00, 325.00, 300.00 }, ;
                 { 220.00, 100.00, 125.00, 300.00, 150.00, 125.00, 85.00, 50.00, 285.00, 275.00, 295.00, 280.00 }, ;
                 { 125.25, 100.00, 100.00, 150.00, 250.00, 300.00, 25.00, 75.00, 300.00, 200.00, 325.00, 300.00 } }
   cImagem    := ""
   cUnidade   := "R$ "
   cTextoVert := ""
   nMax       := 0

   FOR EACH oElement IN aDados
      nMax := Max( nMax, aMax( oElement ) )
   NEXT

   nMax := Round( ( Int( nMax / 10 ) * 10 ) + 10, 2 )

   oRMChart:CreateChart( hWnd, nIdChart, 10, 10, nW, nH, RMC_COLOR_AZURE, RMC_CTRLSTYLE3DLIGHT, .F., cImagem, "", 0, 0 )
   oRMChart:AddRegion( nIdChart, 0, 0, nW, nH, "RmChart", .F. )
   oRMChart:AddCaption( nIdChart, 1, cTitulo, RMC_COLOR_TRANSPARENT, RMC_COLOR_RED, 9, .T. )
   oRMChart:AddGrid( nIdChart, 1, RMC_COLOR_LIGHT_BLUE, .F., 20, 20, nW - 100, nH - 100, RMC_BICOLOR_LABELAXIS )
   oRMChart:AddLabelAxis( nIdChart, 1, cLabels, 1, Len( aDados[ 1 ] ), RMC_LABELAXISBOTTOM, 8, RMC_COLOR_BLACK, RMC_TEXTCENTER, RMC_COLOR_BLACK, RMC_LINESTYLENONE, "" )
   oRMChart:AddDataAxis( nIdChart, 1, RMC_DATAAXISRIGHT, 0.0, nMax, Len( aDados[ 1 ] ), 8, RMC_COLOR_BLACK, RMC_COLOR_BLACK, RMC_LINESTYLESOLID, 1, cUnidade, cTextoVert, "", RMC_TEXTCENTER )
   oRMChart:AddLegend( nIdChart, 1, cLegenda, RMC_LEGEND_BOTTOM, RMC_COLOR_TRANSPARENT, RMC_LEGENDNORECT, RMC_COLOR_RED, 8, .T. )

   FOR nCont = 1 TO Len( aDados )
      oRMChart:AddBarSeries( nIdChart, 1, aDados[ nCont ], 12, RMC_BARGROUP, RMC_BAR_FLAT_GRADIENT2, .F., 0, .F., 1, RMC_VLABEL_NONE, nCont, RMC_HATCHBRUSH_ONPRINTING )
   NEXT

   //oRMChart:Draw( nIdChart )
   //oRMCHart:Reset(nIdChart)
   // oRMChart:Draw2Printer( ID_RMC1, 0, 0, 0, 0, 0, RMC_BMP )
   
RETURN NIL